"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = require("lodash");
var CSharp_1 = require("./CSharp");
var Golang_1 = require("./Golang");
var CPlusPlus_1 = require("./CPlusPlus");
var Java_1 = require("./Java");
var SimpleTypes_1 = require("./SimpleTypes");
var TypeScript_1 = require("./TypeScript");
var Swift_1 = require("./Swift");
var Elm_1 = require("./Elm");
var JSONSchema_1 = require("./JSONSchema");
exports.all = [
    new CSharp_1.default(),
    new Golang_1.default(),
    new CPlusPlus_1.default(),
    new Java_1.default(),
    new TypeScript_1.default(),
    new Swift_1.default(),
    new Elm_1.default(),
    new JSONSchema_1.default(),
    new SimpleTypes_1.default()
];
function languageNamed(name) {
    return lodash_1.find(exports.all, function (l) { return lodash_1.includes(l.names, name) || l.displayName === name; });
}
exports.languageNamed = languageNamed;
