import { TypeGraph } from "./TypeGraph";
import { Renderer } from "./Renderer";
import { OptionDefinition, Option } from "./RendererOptions";
import { SerializedRenderResult } from "./Source";
import { StringTypeMapping } from "./TypeBuilder";
export declare abstract class TargetLanguage {
    readonly displayName: string;
    readonly names: string[];
    readonly extension: string;
    private _options?;
    constructor(displayName: string, names: string[], extension: string);
    protected setOptions: (options: Option<any>[]) => void;
    readonly optionDefinitions: OptionDefinition[];
    protected readonly abstract rendererClass: new (graph: TypeGraph, leadingComments: string[] | undefined, ...optionValues: any[]) => Renderer;
    renderGraphAndSerialize(graph: TypeGraph, alphabetizeProperties: boolean, leadingComments: string[] | undefined, rendererOptions: {
        [name: string]: any;
    }, indentation?: string): SerializedRenderResult;
    protected readonly defaultIndentation: string;
    protected readonly partialStringTypeMapping: Partial<StringTypeMapping>;
    readonly stringTypeMapping: StringTypeMapping;
}
