import { Map, Set, OrderedSet, Collection } from "immutable";
import { Type, SeparatedNamedTypes } from "./Type";
import { GraphRewriteBuilder, TypeRef, TypeBuilder, StringTypeMapping } from "./TypeBuilder";
import { TypeNames } from "./TypeNames";
export declare class TypeGraph {
    private _typeBuilder?;
    private _topLevels?;
    private _types?;
    private _typeNames?;
    constructor(typeBuilder: TypeBuilder);
    private readonly isFrozen;
    freeze: (topLevels: Map<string, TypeRef>, types: Type[], typeNames: (TypeNames | undefined)[]) => void;
    readonly topLevels: Map<string, Type>;
    atIndex(index: number): [Type, TypeNames | undefined];
    filterTypes(predicate: (t: Type) => boolean, childrenOfType?: (t: Type) => Collection<any, Type>): OrderedSet<Type>;
    allNamedTypes: (childrenOfType?: ((t: Type) => Collection<any, Type>) | undefined) => OrderedSet<Type>;
    allNamedTypesSeparated: (childrenOfType?: ((t: Type) => Collection<any, Type>) | undefined) => SeparatedNamedTypes;
    rewrite<T extends Type>(stringTypeMapping: StringTypeMapping, replacementGroups: T[][], replacer: (typesToReplace: Set<T>, builder: GraphRewriteBuilder<T>) => TypeRef): TypeGraph;
    allTypesUnordered: () => Set<Type>;
}
