import { OrderedSet, Collection } from "immutable";
export declare type NameOrNames = string | TypeNames;
export declare function makeTypeNames(nameOrNames: NameOrNames, areNamesInferred: boolean): TypeNames;
export declare class TypeNames {
    private _names;
    private _alternativeNames;
    private _areInferred;
    constructor(_names: OrderedSet<string>, _alternativeNames: OrderedSet<string>, _areInferred: boolean);
    copy: () => TypeNames;
    readonly names: OrderedSet<string>;
    readonly areInferred: boolean;
    add(names: TypeNames): void;
    union(names: TypeNames): TypeNames;
    clearInferred: () => void;
    readonly combinedName: string;
    readonly proposedNames: OrderedSet<string>;
    makeInferred: () => TypeNames;
    singularize: () => TypeNames;
}
export declare function typeNamesUnion(c: Collection<any, TypeNames>): TypeNames;
