"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Support_1 = require("./Support");
function expand(json) {
    if (typeof json === "string") {
        return [json];
    }
    if (Array.isArray(json)) {
        var result = [""];
        for (var _i = 0, json_1 = json; _i < json_1.length; _i++) {
            var j = json_1[_i];
            var expanded = expand(j);
            var appended = [];
            for (var _a = 0, result_1 = result; _a < result_1.length; _a++) {
                var a = result_1[_a];
                for (var _b = 0, expanded_1 = expanded; _b < expanded_1.length; _b++) {
                    var b = expanded_1[_b];
                    appended.push(a + b);
                }
            }
            result = appended;
        }
        return result;
    }
    if (Object.prototype.hasOwnProperty.call(json, "oneOf")) {
        var options = Support_1.checkArray(json.oneOf);
        var result = [];
        for (var _c = 0, options_1 = options; _c < options_1.length; _c++) {
            var j = options_1[_c];
            for (var _d = 0, _e = expand(j); _d < _e.length; _d++) {
                var x = _e[_d];
                result.push(x);
            }
        }
        return result;
    }
    return Support_1.panic("Value is not a valid URL grammar: " + json);
}
function urlsFromURLGrammar(json) {
    var topLevelMap = Support_1.checkStringMap(json);
    var results = {};
    for (var _i = 0, _a = Object.getOwnPropertyNames(topLevelMap); _i < _a.length; _i++) {
        var name = _a[_i];
        results[name] = expand(topLevelMap[name]);
    }
    return results;
}
exports.urlsFromURLGrammar = urlsFromURLGrammar;
