"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var stream_1 = require("stream");
function bufferStream(opts) {
    opts = Object.assign({}, opts);
    var array = opts.array;
    var encoding = opts.encoding;
    var buffer = encoding === "buffer";
    var objectMode = false;
    if (array) {
        objectMode = !(encoding || buffer);
    }
    else {
        encoding = encoding || "utf8";
    }
    if (buffer) {
        encoding = undefined;
    }
    var len = 0;
    var ret = [];
    var stream = new stream_1.PassThrough({
        objectMode: objectMode
    });
    if (encoding) {
        stream.setEncoding(encoding);
    }
    stream.on("data", function (chunk) {
        ret.push(chunk);
        if (objectMode) {
            len = ret.length;
        }
        else {
            len += chunk.length;
        }
    });
    stream.getBufferedValue = function () {
        if (array) {
            return ret;
        }
        return buffer ? Buffer.concat(ret, len) : ret.join("");
    };
    stream.getBufferedLength = function () { return len; };
    return stream;
}
exports.default = bufferStream;
